/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.benutzerverwaltung.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.benutzerverwaltung.entity.Nachricht;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class NachrichtExtendedDAO extends AbstractNachrichtDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: CountByUngelesenNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT COUNT(DISTINCT nachricht) FROM Nachricht nachricht LEFT JOIN nachricht.rolles nachrichtRolle WHERE nachricht.mandant=?4 AND ((nachricht.senderkennung <> ?1) AND (nachricht.id > ?2) AND (nachricht.empfaengerGruppeArt = 'ALLE' OR nachrichtRolle.id IN (?3) OR EXISTS(SELECT urspruenglicheNachricht FROM Nachricht urspruenglicheNachricht LEFT JOIN urspruenglicheNachricht.rolles urspruenglicheNachrichtRolle WHERE (urspruenglicheNachricht.id = nachricht.urspruenglicheNachricht.id) AND (urspruenglicheNachricht.senderkennung = ?1 OR urspruenglicheNachricht.empfaengerGruppeArt = 'ALLE' OR urspruenglicheNachrichtRolle.id IN (?3)))))<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByCountByUngelesen( @javax.annotation.Nonnull java.lang.String senderkennung,  @javax.annotation.Nonnull java.lang.Long letzteId,  @javax.annotation.Nonnull java.util.Collection<java.lang.Long> empfaengerRolleIds,  @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Nachricht.findByCountByUngelesen" ,  senderkennung ,  letzteId ,  empfaengerRolleIds ,  mandant  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByCountByUngelesen(): Miss");
        }

        cache.put(key, super.findByCountByUngelesen( senderkennung ,  letzteId ,  empfaengerRolleIds ,  mandant  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByCountByUngelesen(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByCountByUngelesen( senderkennung ,  letzteId ,  empfaengerRolleIds ,  mandant  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
